--------------------------------------------------------------------------------
--
--  CPU: uniao do bloco de dados com o bloco de controle
--
--   FERNANDO GEHM MORAES        03/agosto/2005
--   NEY LAERT VILAR CALAZANS     18/junho/2006
--   CSAR AUGUSTO MISSIO MARCON  10/abril/2008
--
--------------------------------------------------------------------------------
library IEEE;
use IEEE.Std_Logic_1164.all;
use work.PacoteCleopatra.all;

entity Cleopatra is
	port
	(
		clock, reset, hold: in std_logic;
		halt: out std_logic;
		ce, rw: out std_logic;
		address: out internal_bus;
		datain: in internal_bus;
		dataout: out internal_bus
	);
end Cleopatra;

architecture Cleopatra of Cleopatra is

	signal uins: microinstrucao;
	signal n,z,c,v: std_logic;
	signal ir: internal_bus;

begin

	ce <= uins.ce;
	rw <= uins.rw;

	DP: entity work.DataPath port map
	(
		clock => clock,
		reset => reset,
		hold =>hold,
		address => address,
		datain => datain,
		dataout => dataout,
		ir => ir,
		uins => uins,
		n => n,
		z => z,
		c => c,
		v => v
	);

	CPU: entity work.BlocoDeControle port map
	(
		clock => clock,
		reset => reset,
		hold => hold,
		halt => halt,
		ir => ir,
		uins => uins,
		n => n,
		z => z,
		c => c,
		v => v
	);

end Cleopatra;
