-------------------------------------------------------------------------------
--
-- Decodificador para acesso  entrada/sada ou memria
--
--   FERNANDO GEHM MORAES         03/agosto/2005
--   NEY LAERT VILAR CALAZANS     18/junho/2006
--   CSAR AUGUSTO MISSIO MARCON  10/abril/2008
--
-------------------------------------------------------------------------------
library IEEE;
use IEEE.Std_Logic_1164.all;

entity ES_Decoder is
	port
	(
		ce, rw: in std_logic;
		address: in std_logic_vector(7 downto 0);
		ceCPU, rwCPU, ceES, rwES: out std_logic
	);
end ES_Decoder;

architecture ES_Decoder of ES_Decoder is
	signal add_es: std_logic;
begin

    -- Endereos FC a FF designam acesso  entrada e sada
	add_es <= '1' when address >= x"FC" else '0';

	ceCPU <= '1' when ce = '1' and add_es = '0' else '0';
	ceES <= '1' when ce = '1' and add_es = '1' else '0';
	rwCPU <= '1' when rw = '1' and add_es = '0' else '0';
	rwES <= '1' when rw = '1' and add_es = '1' else '0';

end ES_Decoder;
