-------------------------------------------------------------------------------
--
-- Biestveis de estado
-- Este registrador de estado armazena quatro bits referentes aos 4 valores
-- instantneos dos qualificadores de estado (n_inst, z_inst, c_inst, v_inst)
-- quando os sinais de controle (lnz e lcv) indicam que isto deva ocorrer, na
-- borda correta do sinal de relgio (clock). O sinal reset inicializa todos os
-- qualificadores com 0.
--
--   FERNANDO GEHM MORAES         03/agosto/2005
--   NEY LAERT VILAR CALAZANS     18/junho/2006
--   CSAR AUGUSTO MISSIO MARCON  10/abril/2008
--
-------------------------------------------------------------------------------
library IEEE;
use IEEE.Std_Logic_1164.all;
use work.PacoteCleopatra.all;

entity Flags is
	port
	(
		n_inst, z_inst, c_inst, v_inst, lnz, lcv, clock, reset: in std_logic;
		n, z, c, v: out std_logic
	);
end Flags;

architecture Flags of Flags is
begin

	process(clock, reset)
	begin
		if reset = '1' then
			n <= '0';
			z <= '0';
			c <= '0';
			v <= '0';
		elsif clock'event and clock = '0' then
			if lcv = '1' then
				c <= c_inst;
				v <= v_inst;
			end if;
			if lnz = '1' then
				n <= n_inst;
				z <= z_inst;
			end if;
		end if;
	end process;

end Flags;
