.code

Aguarda:
	lda    0FCh         ; Aguarda ser pressionado o BTN1
	and    #02h
	jz     Aguarda
	lda    0FDh         ; L as chaves deslizantes
	sta    0FDh         ; Armazena o valor lido nos leds
	sta    contadorLow  ; Armazena o valor lido na parte baixa do contador
	lda	 #0		  ; carrega 0 no acumulador
	sta	 contadorHigh ; inicializa parte alta do contador

Volta:
	lda    contadorLow  ; Incrementa parte baixa do contador
	add    #01h
	sta    contadorLow  ; armazena em contadorLow
	jc     Carry,R      ; se deu carry, vai adicionar 1 a contadorHigh
	jmp    Exibe,R	  ; senao, resultado est pronto, vai exibir no display

Carry:
	lda    contadorHigh 
	add    #01h
	sta    contadorHigh ; incrementa parte alta do contador

Exibe:
	lda    contadorLow
	sta    0FFh         ; escreve parte baixa nos 2 displays mais  direita

	lda    contadorHigh
	sta    0FEh         ; escreve parte alta nos 2 displays mais  esquerda

	lda    0FCh         ; Se pressionado o BTN2 termina
	and    #04h
	jz     Pula
	jmp    Fim

Pula:
	jsr    Tempo,R      ; Chama rotina para passar tempo
	jmp    Volta

Fim:
	hlt                 ; fim do programa

;--------------------------------------------------------------------------
;  Rotina que espera um tempo equivalente a aproximadamente
; (tt*(2*tt)) ciclos de relogio
;--------------------------------------------------------------------------
Tempo:
	lda    tt
	sta    t1          ; inicializa contador t1 com tt(255)
Ltime:
	lda    t1          ; carrega contador t1
	add    #0FFH
	sta    t1          ; decrementa t1
	jz     F4,R        ; fim, quando contador chega em 0
	lda    tt          ; senao, inicializa AC com tt(255)
F1:
	add    #0FFh       ; conta at 0
	jz     F2,R        ; e a, vai para f2
	jmp    f1,R

F2:
	lda    tt          ; aqui, inicializa AC de novo com tt(255)
F3:
	add    #0FFh       ; conta at 0
	jz     F5,R        ; ento, vai para f5
	jmp    F3,R

F5:
	jmp    Ltime,R
F4:
	rts

.endcode

.data

	contadorHigh:   db    #00h
	contadorLow:    db    #00h
	t1:             db    #00h
	tt:             db    #0FFh

.enddata
