-------------------------------------------------------------------------------
--
-- memria na forma de um vetor - cdigo objeto definido em package
--
--   FERNANDO GEHM MORAES         03/agosto/2005
--   NEY LAERT VILAR CALAZANS     18/junho/2006
--   CSAR AUGUSTO MISSIO MARCON  10/abril/2008
--
-------------------------------------------------------------------------------
library IEEE;
use IEEE.Std_Logic_Unsigned.all;
use IEEE.Std_Logic_1164.all;
use work.object_code.all;            -- cdigo objeto definido neste package

entity RAM_mem is
	port
	(
		clock, ce, rw: in std_logic;
		address: in std_logic_vector(7 downto 0);
		datain: in std_logic_vector(7 downto 0);
		dataout: out std_logic_vector(7 downto 0)
	);
end RAM_mem;

architecture RAM_mem of RAM_mem is
begin

	process(clock)
	begin
		if clock'event and clock = '1' then
			if ce = '1' and rw = '0' then
				memoria(CONV_INTEGER(address)) <= datain;   -- writes in memory
			end if;
			dataout <= memoria(CONV_INTEGER(address));      -- memory reading
		end if;
	end process;

end RAM_mem;
