-------------------------------------------------------------------------------
--
-- Registrador Bsico
-- Com reset assncrono e habilitao de escrita
--
--   FERNANDO GEHM MORAES         03/agosto/2005
--   NEY LAERT VILAR CALAZANS     18/junho/2006
--   CSAR AUGUSTO MISSIO MARCON  10/abril/2008
--
-------------------------------------------------------------------------------
library IEEE;
use IEEE.Std_Logic_1164.all;
use work.PacoteCleopatra.all;

entity RegistradorClear is
	port
	(
		clock, reset, ce: in std_logic;
		D: in internal_bus;
		Q: out internal_bus
	);
end RegistradorClear;

architecture RegistradorClear of RegistradorClear is
begin

	process(clock, reset)
	begin
		if reset = '1' then
			Q <= (others => '0');
		elsif clock'event and clock = '0' then
			if ce = '1' then
				Q <= D;
			end if;
		end if;
	end process;

end RegistradorClear;
