-------------------------------------------------------------------------------
--
-- Test bench
--
--   FERNANDO GEHM MORAES         03/agosto/2005
--   NEY LAERT VILAR CALAZANS     18/junho/2006
--   CSAR AUGUSTO MISSIO MARCON  10/abril/2008
--
-------------------------------------------------------------------------------
library IEEE;
use IEEE.Std_Logic_1164.all;
use IEEE.Std_Logic_Unsigned.all;
use IEEE.Std_Logic_Arith.all;

entity Tb is
end Tb;

architecture Tb of Tb is

	signal ck, reset: std_logic;
	signal an: std_logic_vector(4 downto 1);
	signal btns: std_logic_vector(3 downto 1);
	signal dec_ddp, dipsw, leds: std_logic_vector(7 downto 0);

begin

	UUT: entity work.Top port map
	(
		ck => ck,
		reset => reset,
		dipsw => dipsw,
		btns => btns,
		leds => leds,
		an => an,
		dec_ddp => dec_ddp
	);

	reset <= '1', '0' after 5 ns, '1' after 150 ns, '0' after 250 ns;
	btns <= "000";

	process
	begin
		ck <= '1', '0' after 20 ns;
		wait for 40 ns;
	end process;

	dipsw <= x"01", x"00" after 150us;

end Tb;
